Loading...
Searching...
No Matches
Core functions
libavformat

Functions for querying libavformat capabilities, allocating core structures, etc. More...

## Functions

unsigned | avformat_version (void)
| Return the LIBAVFORMAT_VERSION_INT constant.
const char * | avformat_configuration (void)
| Return the libavformat build-time configuration.
const char * | avformat_license (void)
| Return the libavformat license.
int | avformat_network_init (void)
| Do global initialization of network libraries.
int | avformat_network_deinit (void)
| Undo the initialization done by avformat_network_init.
const AVOutputFormat * | av_muxer_iterate (void **opaque)
| Iterate over all registered muxers.
const AVInputFormat * | av_demuxer_iterate (void **opaque)
| Iterate over all registered demuxers.
AVFormatContext * | avformat_alloc_context (void)
| Allocate an AVFormatContext.
void | avformat_free_context (AVFormatContext *s)
| Free an AVFormatContext and all its streams.
const AVClass * | avformat_get_class (void)
| Get the AVClass for AVFormatContext.
const AVClass * | av_stream_get_class (void)
| Get the AVClass for AVStream.
const AVClass * | av_stream_group_get_class (void)
| Get the AVClass for AVStreamGroup.
const char * | avformat_stream_group_name (enum AVStreamGroupParamsType type)
AVStreamGroup * | avformat_stream_group_create (AVFormatContext *s, enum AVStreamGroupParamsType type, AVDictionary **options)
| Add a new empty stream group to a media file.
AVStream * | avformat_new_stream (AVFormatContext *s, const struct AVCodec *c)
| Add a new stream to a media file.
int | avformat_stream_group_add_stream (AVStreamGroup *stg, AVStream *st)
| Add an already allocated stream to a stream group.
AVProgram * | av_new_program (AVFormatContext *s, int id)

## Detailed Description

Functions for querying libavformat capabilities, allocating core structures, etc.

## Function Documentation

## avformat_version()

unsigned avformat_version | ( | void |  | ) |

Return the LIBAVFORMAT_VERSION_INT constant.

## avformat_configuration()

const char * avformat_configuration | ( | void |  | ) |

Return the libavformat build-time configuration.

## avformat_license()

const char * avformat_license | ( | void |  | ) |

Return the libavformat license.

## avformat_network_init()

int avformat_network_init | ( | void |  | ) |

Do global initialization of network libraries.

This is optional, and not recommended anymore.

This functions only exists to work around thread-safety issues with older GnuTLS or OpenSSL libraries. If libavformat is linked to newer versions of those libraries, or if you do not use them, calling this function is unnecessary. Otherwise, you need to call this function before any other threads using them are started.

This function will be deprecated once support for older GnuTLS and OpenSSL libraries is removed, and this function has no purpose anymore.

Examples
  avio_list_dir.c.

Referenced by main().

## avformat_network_deinit()

int avformat_network_deinit | ( | void |  | ) |

Undo the initialization done by avformat_network_init.

Call it only once for each time you called avformat_network_init.

Examples
  avio_list_dir.c.

Referenced by main().

## av_muxer_iterate()

const AVOutputFormat * av_muxer_iterate | ( | void ** | opaque | ) |

Iterate over all registered muxers.

Parameters

  opaque | a pointer where libavformat will store the iteration state. Must point to NULL to start the iteration.

Returns
  the next registered muxer or NULL when the iteration is finished

## av_demuxer_iterate()

const AVInputFormat * av_demuxer_iterate | ( | void ** | opaque | ) |

Iterate over all registered demuxers.

Parameters

  opaque | a pointer where libavformat will store the iteration state. Must point to NULL to start the iteration.

Returns
  the next registered demuxer or NULL when the iteration is finished

## avformat_alloc_context()

AVFormatContext * avformat_alloc_context | ( | void |  | ) |

Allocate an AVFormatContext.

avformat_free_context() can be used to free the context and everything allocated by the framework within it.

Examples
  avio_read_callback.c, and transcode_aac.c.

Referenced by main(), and open_output_file().

## avformat_free_context()

void avformat_free_context | ( | AVFormatContext * | s | ) |

Free an AVFormatContext and all its streams.

Parameters

  s | context to free

Examples
  mux.c, remux.c, transcode.c, and transcode_aac.c.

Referenced by main(), and open_output_file().

## avformat_get_class()

const AVClass * avformat_get_class | ( | void |  | ) |

Get the AVClass for AVFormatContext.

It can be used in combination with AV_OPT_SEARCH_FAKE_OBJ for examining options.

See also
  av_opt_find().

## av_stream_get_class()

const AVClass * av_stream_get_class | ( | void |  | ) |

Get the AVClass for AVStream.

It can be used in combination with AV_OPT_SEARCH_FAKE_OBJ for examining options.

See also
  av_opt_find().

## av_stream_group_get_class()

const AVClass * av_stream_group_get_class | ( | void |  | ) |

Get the AVClass for AVStreamGroup.

It can be used in combination with AV_OPT_SEARCH_FAKE_OBJ for examining options.

See also
  av_opt_find().

## avformat_stream_group_name()

const char * avformat_stream_group_name | ( | enum AVStreamGroupParamsType | type | ) |

Returns
  a string identifying the stream group type, or NULL if unknown

## avformat_stream_group_create()

AVStreamGroup * avformat_stream_group_create | ( | AVFormatContext * | s,
|  | enum AVStreamGroupParamsType | type,
|  | AVDictionary ** | options
| ) |  |

Add a new empty stream group to a media file.

When demuxing, it may be called by the demuxer in read_header(). If the flag AVFMTCTX_NOHEADER is set in s.ctx_flags, then it may also be called in read_packet().

When muxing, may be called by the user before avformat_write_header().

User is required to call avformat_free_context() to clean up the allocation by avformat_stream_group_create().

New streams can be added to the group with avformat_stream_group_add_stream().

Parameters

  s | media file handle

Returns
  newly created group or NULL on error.

See also
  avformat_new_stream, avformat_stream_group_add_stream.

## avformat_new_stream()

AVStream * avformat_new_stream | ( | AVFormatContext * | s,
|  | const struct AVCodec * | c
| ) |  |

Add a new stream to a media file.

When demuxing, it is called by the demuxer in read_header(). If the flag AVFMTCTX_NOHEADER is set in s.ctx_flags, then it may also be called in read_packet().

When muxing, should be called by the user before avformat_write_header().

User is required to call avformat_free_context() to clean up the allocation by avformat_new_stream().

Parameters

  s | media file handle
  c | unused, does nothing

Returns
  newly created stream or NULL on error.

Examples
  mux.c, qsv_transcode.c, remux.c, transcode.c, transcode_aac.c, and vaapi_transcode.c.

Referenced by add_stream(), dec_enc(), dec_enc(), main(), open_output_file(), and open_output_file().

## avformat_stream_group_add_stream()

int avformat_stream_group_add_stream | ( | AVStreamGroup * | stg,
|  | AVStream * | st
| ) |  |

Add an already allocated stream to a stream group.

When demuxing, it may be called by the demuxer in read_header(). If the flag AVFMTCTX_NOHEADER is set in s.ctx_flags, then it may also be called in read_packet().

When muxing, may be called by the user before avformat_write_header() after having allocated a new group with avformat_stream_group_create() and stream with avformat_new_stream().

User is required to call avformat_free_context() to clean up the allocation by avformat_stream_group_add_stream().

Parameters

  stg | stream group belonging to a media file.
  st | stream in the media file to add to the group.

Return values

  0 | success
  AVERROR(EEXIST) | the stream was already in the group
  another negative error code | legitimate errors

See also
  avformat_new_stream, avformat_stream_group_create.

## av_new_program()

AVProgram * av_new_program | ( | AVFormatContext * | s,
|  | int | id
| ) |  |